#ifndef BOSS_H
#define BOSS_H

#include "Cell.h"
#include "Difficulty.h"
#include "GameState.h"
#include "GameTypes.h"
#include "Interactable.h"
#include "MapManager.h"
#include "Player.h"
#include "sprites/BossSprites.h"

// Determines when the boss redraw should happen.
extern u8 bossRedraw;

// The boss cells on the map.
extern u8* mapBossCells;

// The number of cells that the boss occupies.
extern u8 mapBossCellCount;

// The amount of health that the final boss has.
extern u8 finalBossHealth;

// Draws the components of the boss on the screen.
void drawBossCells(u8 xScroll, u8 yScroll);

void drawBossCell(i8 x, i8 y, u8 type, u8 cell);

// Updates the position of the final boss within the map.
void updateBossPositionInMap(u16 bossPosition, u16 newBossPosition);

void convertToPlant(u8 cell);

u16 nextPosition(u16 position);

u8 isPlant(u8 cell);

#endif