#include "Dialog.h"

#define EXIT_DIALOG_WIDTH_ 36
#define EXIT_DIALOG_HEIGHT_ 20
#define EXIT_DIALOG_X_ 22
#define DIALOG_Y_ 44
#define DIALOG_Y_TEXT_ 45
#define INVENTORY_DIALOG_HEIGHT_ 110
#define INVENTORY_DIALOG_WIDTH_ 36
#define INVENTORY_DIALOG_X_ 21
#define INVENTORY_EQUIP_Y_ 130

// INVENTORY_DIALOG_X_ + 2
#define INVENTORY_EQUIP_LEFT_X_ 23

u8 exitDialog()
{
    u8* memory = cpct_getScreenPtr(CPCT_VMEM_START, EXIT_DIALOG_X_, DIALOG_Y_);
    cpct_drawSolidBox(memory, cpct_px2byteM0(4, 4) , EXIT_DIALOG_WIDTH_, EXIT_DIALOG_HEIGHT_ );   
    drawString(EXIT_DIALOG_X_ + 1, DIALOG_Y_TEXT_ + 3, "exit game  y or n");

    //break out of the loop once the user decides
    while(1)
    {
        if(cpct_isKeyPressed(Key_Y))
        {
            return TRUE;
        }
        else if(cpct_isKeyPressed(Key_N))
        {            
            //clear just the dialog
            memory = cpct_getScreenPtr(CPCT_VMEM_START, EXIT_DIALOG_X_, DIALOG_Y_);
            cpct_drawSolidBox(memory, cpct_px2byteM0(0, 0), EXIT_DIALOG_WIDTH_, EXIT_DIALOG_HEIGHT_ );

            return FALSE;
        }
    }
}

void inventoryDialog()
{
	u8 itemXPosition = INVENTORY_DIALOG_X_ + 2;
	u8 itemYPosition = DIALOG_Y_ + 16;
	u8 position = 0;
	u8 cursorLine = 0;
	u8 line = 0;
	u8 currentFlag = 1;
	u8 cursorFlag = 1;
	u8 cursorPosition = 0;
	u8 initialDisplay = inventoryItemCount;
	u8 previousCursorFlag = 1;
	u8 itemChange = TRUE;

	u8* memory = cpct_getScreenPtr(CPCT_VMEM_START, INVENTORY_DIALOG_X_, DIALOG_Y_);
	cpct_drawSolidBox(memory, cpct_px2byteM0(4, 4), INVENTORY_DIALOG_WIDTH_, INVENTORY_DIALOG_HEIGHT_);
	drawString(EXIT_DIALOG_X_ + 1, DIALOG_Y_TEXT_ + 1, "inventory");

	// Testing variables.
	// INVENTORY_LINE_1 = 255;
	// INVENTORY_LINE_2 = 255;
	// INVENTORY_LINE_3 = 255;
	// inventoryItemCount = 20;

	// Exit the dialog when the exit key is pressed
	while (1)
	{
		if (cursorFlag != previousCursorFlag || initialDisplay)
		{
			u8* sprite = NULL;
			itemYPosition = DIALOG_Y_ + 16;
			memory = cpct_getScreenPtr(CPCT_VMEM_START, itemXPosition, itemYPosition);
			
			position = 0;				

			for (line = 0; line < INVENTORY_LINE_COUNT; ++line)
			{
				currentFlag = 1;

				while (currentFlag)
				{
					if (currentFlag & inventory[line])
					{
						sprite = itemGraphics[position + 2];
						cpct_drawSprite(sprite, memory, TILE_WIDTH_BYTES, TILE_HEIGHT);

						// Make sure cursor is on the currentl line and matches the current square based on flag value.
						if (cursorFlag == currentFlag && line == cursorLine || initialDisplay)
						{
							cpct_drawSpriteMasked(G_highlighted_mask_black, memory, TILE_WIDTH_BYTES, TILE_HEIGHT);

							// This way the first item in the inventory will be selected.
							if (initialDisplay)
							{
								initialDisplay = FALSE;
								cursorFlag = currentFlag;
								cursorLine = line;
							}							
						}						
					}

					// Move to the next square along the line.
					memory += TILE_WIDTH_BYTES;
					currentFlag <<= 1;
					++position;
				}

				// Move to the next line.
				itemYPosition += 24;
				memory = cpct_getScreenPtr(CPCT_VMEM_START, itemXPosition, itemYPosition);				
			}

			previousCursorFlag = cursorFlag;
		}

		memory = cpct_getScreenPtr(CPCT_VMEM_START, INVENTORY_EQUIP_LEFT_X_, INVENTORY_EQUIP_Y_);

		// Draw a box and a sprite for the left equipped item sprite.
		if (itemChange)
		{
			if (inventoryLeftItem)
			{
				drawItemBox(memory, itemGraphics[inventoryLeftItem - 1]);
			}
			else
			{
				// Draw an empty box if empty handed.
				drawItemBox(memory, NULL);
			}
		}

		// Not a huge separation but enough for now.
		memory += 13;

		// Draw a box and a sprite for the right equipped item sprite.
		if (itemChange)
		{
			if (inventoryRightItem)
			{
				drawItemBox(memory, itemGraphics[inventoryRightItem - 1]);
			}
			else
			{
				// Draw an empty box if empty handed.
				drawItemBox(memory, NULL);
			}
		}

		// Not a huge separation but enough for now.
		memory += 13;

		if (itemChange)
		{
			if (inventoryToDropItem)
			{
				// Draw a box and a sprite for the deployed sprite.
				drawItemBox(memory, itemGraphics[inventoryToDropItem - 1]);
			}
			else
			{
				// Draw an empty box if empty handed.
				drawItemBox(memory, NULL);
			}
		}

		// Prevents continuous redraw of the equipped item boxes.
		itemChange = FALSE;
    
        if(gameControls.exitIsDown)   
        {
            return;
        }

		// Read arrow, use and exit controls.
		readGameControls();

		// No need to support any other controls if there is nothing in the inventory.
		// Controls are locked if a wood block is being carried.
		if (inventoryItemCount && inventoryLeftItem != ITEM_WOOD_BLOCK && inventoryToDropItem != ITEM_WOOD_BLOCK)
		{
			if (gameControls.leftIsDown)
			{
				if (cursorFlag > lowestBit(inventory[cursorLine]))
				{
					do
					{
						cursorFlag >>= 1;
					} 
					while (!(cursorFlag & inventory[cursorLine]));
				}
			}
			else if (gameControls.rightIsDown)
			{
				if (cursorFlag < highestBit(inventory[cursorLine]))
				{
					do
					{
						cursorFlag <<= 1;
					} 
					while (!(cursorFlag & inventory[cursorLine]));
				}
			}
			else if (gameControls.downIsDown)
			{
				// Make sure it is in range.
				if (cursorLine + 1 < INVENTORY_LINE_COUNT)
				{
					// Check that there is something on the next line.
					if (inventory[cursorLine + 1])
					{
						++cursorLine;
						previousCursorFlag = 255;
						cursorFlag = lowestBit(inventory[cursorLine]);
					}
					else if (cursorLine + 2 < INVENTORY_LINE_COUNT)
					{
						// Check that there is something on the next next line.
						if (inventory[cursorLine + 2])
						{
							cursorLine += 2;
							previousCursorFlag = 255;
							cursorFlag = lowestBit(inventory[cursorLine]);
						}
					}
				}
			}
			else if (gameControls.upIsDown)
			{
				// Make sure it is in range.
				if (cursorLine - 1 >= 0)
				{
					// Check that there is something on the previous line.
					if (inventory[cursorLine - 1])
					{
						--cursorLine;
						previousCursorFlag = 255;
						cursorFlag = lowestBit(inventory[cursorLine]);
					}
					else if (cursorLine - 2 >= 0)
					{
						// Check that there is something on the previous previous line.
						if (inventory[cursorLine - 2])
						{
							cursorLine -= 2;
							previousCursorFlag = 255;
							cursorFlag = lowestBit(inventory[cursorLine]);
						}
					}
				}
			}
			else if (cpct_isKeyPressed(Key_1))
			{
				// Equip an item in the left hand.
				equipItem(cursorLine, cursorFlag, EQUIP_ITEM_LH);

				itemChange = TRUE;
			}
			else if (cpct_isKeyPressed(Key_2))
			{
				// Equip an item in the right hand.
				equipItem(cursorLine, cursorFlag, EQUIP_ITEM_RH);

				itemChange = TRUE;
			}
			else if (cpct_isKeyPressed(Key_3))
			{
				// Drop the item moving it to the drop item variable.
				dropItem(inventoryFlagToItemType(cursorLine, cursorFlag));

				itemChange = TRUE;
			}
			else if (cpct_isKeyPressed(Key_4))
			{
				// Unequip the item if it is currently equipped.
				unequipItem(inventoryFlagToItemType(cursorLine, cursorFlag));
				itemChange = TRUE;
			}
		}
		else if (inventoryLeftItem == ITEM_WOOD_BLOCK || inventoryToDropItem == ITEM_WOOD_BLOCK)
		{
			if (cpct_isKeyPressed(Key_1))
			{
				// Equip the wood block.
				equipItem(1, INVENTORY_ITEM_WOOD_BLOCK, EQUIP_ITEM_LH);

				itemChange = TRUE;
			}
			else if (cpct_isKeyPressed(Key_2))
			{
				// Equip the wood block.
				equipItem(1, INVENTORY_ITEM_WOOD_BLOCK, EQUIP_ITEM_RH);

				itemChange = TRUE;
			}
			else if (cpct_isKeyPressed(Key_3))
			{
				// Drop the wood block moving it to the drop item variable.
				dropItem(inventoryFlagToItemType(1, INVENTORY_ITEM_WOOD_BLOCK));

				itemChange = TRUE;
			}			
		}

		// Ensure the arrow key values are false at the end of the loop.
		while (gameControls.upIsDown || gameControls.downIsDown || gameControls.leftIsDown || gameControls.rightIsDown)
		{
			readGameControls();
		}
    }
}

void drawItemBox(u8* memory, u8* graphic)
{
	// Draw a box for the left equipped sprite.
	cpct_drawSolidBox(memory, cpct_px2byteM0(0, 0), TILE_WIDTH_BYTES + 2, TILE_HEIGHT);

	if (graphic)
	{
		// Draw the sprite inside the box (161 = 1 + SCREEN_X*2).
		cpct_drawSprite(graphic, memory + 1, TILE_WIDTH_BYTES, TILE_HEIGHT);
	}	
}