#ifndef DIFFICULTY_H
#define DIFFICULTY_H

#include <types.h>

#define EASY_DIFFICULTY 0
#define NORMAL_DIFFICULTY 1
#define HARD_DIFFICULTY 2

#define OIL_FUEL_DEPLETION_RATE 70
#define BATTERY_FUEL_DEPLETION_RATE 90

// The amount of health the player starts with.
extern u8 startingHealth;

// The maximum amount of health the player can have.
extern u8 maxHealth;

// The amount of health a health item gives to the player on pickup.
extern u8 healthItemValue;

// The difficulty level chosen by the player for the game.
extern u8 chosenDifficulty;

// Length of the light beam for torch and scuba gear.
extern u8 lightBeamLength;

// The number of cells outwards on the y axis for the oil lamp.
extern u8 lightCellsOutY;

// The number of moves that the player can make in the dark before dieing.
extern u8 maxDarkMoves;

// The amount of health that the final boss will start with.
extern u8 finalBossStartingHealth;

// The amount of damage the boss does if it moves\lands on the player.
extern u8 bossMoveDamage;

// The amount of meat that the gesture plant requires before it lets the player through.
extern u8 plantHunger;

// Sets up all the difficulty values for the game.
void setupDifficulty();

// Set the default dark move values.
void setDarkMoves();

#endif