#ifndef KEYS_H
#define KEYS_H

#include <cpctelera.h>
#include "GameTypes.h"

typedef struct Keys Keys;

struct Keys
{
    cpct_keyID left;
    cpct_keyID right;
    cpct_keyID up;
    cpct_keyID down;
    cpct_keyID use;
    cpct_keyID exit;
    cpct_keyID inventory;
	cpct_keyID attack;
    u8 leftIsDown : 1;
    u8 rightIsDown : 1;
    u8 upIsDown : 1;
    u8 downIsDown : 1;
    u8 useIsDown : 1;
	u8 exitIsDown : 1;
	u8 attackIsDown : 1;
};

//sets the default keys when the game first loads
void setupDefaultKeys();

//initialises IsDown values so that no keys are pressed at the start of the game
void initKeys();

extern Keys gameControls;

void readGameControls();

#endif