#ifndef MAP_H
#define MAP_H

#include <cpctelera.h>
#include "Boss.h"
#include "Cell.h"
#include "Enemy.h"
#include "GameState.h"
#include "GameTypes.h"
#include "Interactable.h"
#include "Item.h"
#include "Lighting.h"
#include "MapManager.h"
#include "Tile.h"
#include "sprites/TileSprites.h"
#include "sprites/ItemSprites.h"
#include "sprites/InteractableSprites.h"

//determine when a map redraw should happen
extern u8 mapRedraw;

void initMap(u8 mapNumber);

void drawMap(u8 xScroll, u8 yScroll);

void drawCell(u8 x, u8 y, u8 cell);

void drawBlankCell(u8 x, u8 y);

void activateLinkedInteractable(u8 x, u8 y, u8 parent);

void activeInteractable(u8 x, u8 y, u8 parent);

#endif