#include "MapManager.h"

u8* const cave_map[CAVE_COUNT] = 
{
	map_EntranceCave_compressed, 
    map_EnemiesAndWalls_compressed, 
	map_GrowingPlant_compressed, 
    map_KeysAndDoors_compressed, 
    map_WoodBlock_compressed, 
    map_KeyCards_compressed, 
    map_Gesture_compressed, 
    map_Mines_compressed, 
    map_Rivers_compressed, 	
	map_Teleporters_compressed, 
	map_Impassable_compressed, 
	map_FinalBoss_compressed
};

u8* const cave_links[CAVE_COUNT] = 
{
	NULL, 
    NULL, 
	NULL, 
    NULL, 
    map_WoodBlock_links, 
    map_KeyCards_links, 
    NULL, 
    map_Mines_links, 
    NULL, 	
	map_Teleporters_links, 
	map_Impassable_links, 
	NULL
};

u8* const cave_entrances[CAVE_COUNT] = 
{
	map_EntranceCave_entrances,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL
};

u8* const cave_enemies[CAVE_COUNT] = 
{
	NULL, 
    map_EnemiesAndWalls_enemies, 
	map_GrowingPlant_enemies, 
    NULL, 
    map_WoodBlock_enemies, 
    map_KeyCards_enemies, 
    map_Gesture_enemies, 
    map_Mines_enemies, 
    map_Rivers_enemies, 	
	map_Teleporters_enemies, 
	NULL, 
	map_FinalBoss_enemies
};

u8* const cave_start_position[CAVE_COUNT] = 
{ 
	map_EntranceCave_startPosition, 
    map_EnemiesAndWalls_startPosition, 
	map_GrowingPlant_startPosition, 
    map_KeysAndDoors_startPosition, 
    map_WoodBlock_startPosition, 
    map_KeyCards_startPosition, 
    map_Gesture_startPosition, 
    map_Mines_startPosition, 
    map_Rivers_startPosition, 	
	map_Teleporters_startPosition, 
	map_Impassable_startPosition, 
	map_FinalBoss_startPosition
};

u8* const cave_boss[CAVE_COUNT] = 
{
	NULL, 
    NULL, 
	map_GrowingPlant_boss, 
    NULL, 
    NULL, 
    NULL, 
    map_Gesture_boss, 
    NULL, 
    NULL, 	
	NULL, 
	NULL, 
	map_FinalBoss_boss
};

u8* const cave_static_light_sources[CAVE_COUNT] = 
{
	map_EntranceCave_static_light_sources, 
    NULL, 
	NULL, 
    map_KeysAndDoors_static_light_sources, 
    NULL, 
    NULL, 
    NULL, 
    map_Mines_static_light_sources, 
    NULL, 	
	NULL, 
	map_Impassable_static_light_sources, 
	map_FinalBoss_static_light_sources
};

const u16 cave_map_size[CAVE_COUNT] = 
{
	MAP_ENTRANCECAVE_COMPRESSED_SIZE,
	MAP_ENEMIESANDWALLS_COMPRESSED_SIZE,
    MAP_GROWINGPLANT_COMPRESSED_SIZE,
	MAP_KEYSANDDOORS_COMPRESSED_SIZE,
    MAP_WOODBLOCK_COMPRESSED_SIZE,
    MAP_KEYCARDS_COMPRESSED_SIZE,
    MAP_GESTURE_COMPRESSED_SIZE,
    MAP_MINES_COMPRESSED_SIZE,
    MAP_RIVERS_COMPRESSED_SIZE,    
	MAP_TELEPORTERS_COMPRESSED_SIZE,
	MAP_IMPASSABLE_COMPRESSED_SIZE,
	MAP_FINALBOSS_COMPRESSED_SIZE
};

const u8 cave_link_count[CAVE_COUNT] = 
{
	MAP_ENTRANCECAVE_LINK_ELEMENT_COUNT,
	MAP_ENEMIESANDWALLS_LINK_ELEMENT_COUNT,
    MAP_GROWINGPLANT_LINK_ELEMENT_COUNT,
	MAP_KEYSANDDOORS_LINK_ELEMENT_COUNT,
    MAP_WOODBLOCK_LINK_ELEMENT_COUNT,
    MAP_KEYCARDS_LINK_ELEMENT_COUNT,
    MAP_GESTURE_LINK_ELEMENT_COUNT,
    MAP_MINES_LINK_ELEMENT_COUNT,
    MAP_RIVERS_LINK_ELEMENT_COUNT,    
	MAP_TELEPORTERS_LINK_ELEMENT_COUNT,
	MAP_IMPASSABLE_LINK_ELEMENT_COUNT,
	MAP_FINALBOSS_LINK_ELEMENT_COUNT
};

const u16 cave_enemy_count[CAVE_COUNT] = 
{
	MAP_ENTRANCECAVE_ENEMY_ELEMENT_COUNT,
	MAP_ENEMIESANDWALLS_ENEMY_ELEMENT_COUNT,
    MAP_GROWINGPLANT_ENEMY_ELEMENT_COUNT,
	MAP_KEYSANDDOORS_ENEMY_ELEMENT_COUNT,
    MAP_WOODBLOCK_ENEMY_ELEMENT_COUNT,
    MAP_KEYCARDS_ENEMY_ELEMENT_COUNT,
    MAP_GESTURE_ENEMY_ELEMENT_COUNT,
    MAP_MINES_ENEMY_ELEMENT_COUNT,
    MAP_RIVERS_ENEMY_ELEMENT_COUNT,    
	MAP_TELEPORTERS_ENEMY_ELEMENT_COUNT,
	MAP_IMPASSABLE_ENEMY_ELEMENT_COUNT,
	MAP_FINALBOSS_ENEMY_ELEMENT_COUNT
};

const u8 cave_boss_cell_count[CAVE_COUNT] = 
{
	MAP_ENTRANCECAVE_BOSS_ELEMENT_COUNT,
	MAP_ENEMIESANDWALLS_BOSS_ELEMENT_COUNT,
    MAP_GROWINGPLANT_BOSS_ELEMENT_COUNT,
	MAP_KEYSANDDOORS_BOSS_ELEMENT_COUNT,
    MAP_WOODBLOCK_BOSS_ELEMENT_COUNT,
    MAP_KEYCARDS_BOSS_ELEMENT_COUNT,
    MAP_GESTURE_BOSS_ELEMENT_COUNT,
    MAP_MINES_BOSS_ELEMENT_COUNT,
    MAP_RIVERS_BOSS_ELEMENT_COUNT,    
	MAP_TELEPORTERS_BOSS_ELEMENT_COUNT,
	MAP_IMPASSABLE_BOSS_ELEMENT_COUNT,
	MAP_FINALBOSS_BOSS_ELEMENT_COUNT
};

const u8 cave_static_light_source_count[CAVE_COUNT] = 
{
	MAP_ENTRANCECAVE_STATIC_LIGHT_SOURCE_ELEMENT_COUNT,
	MAP_ENEMIESANDWALLS_STATIC_LIGHT_SOURCE_ELEMENT_COUNT,
    MAP_GROWINGPLANT_STATIC_LIGHT_SOURCE_ELEMENT_COUNT,
	MAP_KEYSANDDOORS_STATIC_LIGHT_SOURCE_ELEMENT_COUNT,
    MAP_WOODBLOCK_STATIC_LIGHT_SOURCE_ELEMENT_COUNT,
    MAP_KEYCARDS_STATIC_LIGHT_SOURCE_ELEMENT_COUNT,
    MAP_GESTURE_STATIC_LIGHT_SOURCE_ELEMENT_COUNT,
    MAP_MINES_STATIC_LIGHT_SOURCE_ELEMENT_COUNT,
    MAP_RIVERS_STATIC_LIGHT_SOURCE_ELEMENT_COUNT,    
	MAP_TELEPORTERS_STATIC_LIGHT_SOURCE_ELEMENT_COUNT,
	MAP_IMPASSABLE_STATIC_LIGHT_SOURCE_ELEMENT_COUNT,
	MAP_FINALBOSS_STATIC_LIGHT_SOURCE_ELEMENT_COUNT
};