#ifndef MAPMANAGER_H
#define MAPMANAGER_H

#include <types.h>
#include "GameTypes.h"
#include "maps/EnemiesAndWalls.h"
#include "maps/EntranceCave.h"
#include "maps/FinalBoss.h"
#include "maps/Gesture.h"
#include "maps/GrowingPlant.h"
#include "maps/Impassable.h"
#include "maps/KeysAndDoors.h"
#include "maps/KeyCards.h"
#include "maps/Mines.h"
#include "maps/Rivers.h"
#include "maps/Teleporters.h"
#include "maps/WoodBlock.h"


#define CAVE_COUNT 12

#define ENTRANCE_CAVE_LEVEL 0
// ENEMIES_AND_WALLS_LEVEL 1
#define GROWING_PLANT_LEVEL 2
// KEYS_LEVEL 3
// WOOD_BLOCK_LEVEL 4
// KEY_CARDS_LEVEL 5
#define GESTURE_LEVEL 6
// MINES_LEVEL 7
#define RIVERS_LEVEL 8
// TELEPORTERS_LEVEL 9
#define IMPASSABLE_LEVEL 10
#define BOSS_LEVEL 11

extern u8* const cave_map[CAVE_COUNT];
extern u8* const cave_links[CAVE_COUNT];
extern u8* const cave_entrances[CAVE_COUNT];
extern u8* const cave_enemies[CAVE_COUNT];
extern u8* const cave_start_position[CAVE_COUNT];
extern u8* const cave_boss[CAVE_COUNT];
extern u8* const cave_static_light_sources[CAVE_COUNT];
extern const u16 cave_map_size[CAVE_COUNT];
extern const u8 cave_link_count[CAVE_COUNT];
extern const u16 cave_enemy_count[CAVE_COUNT];
extern const u8 cave_boss_cell_count[CAVE_COUNT];
extern const u8 cave_static_light_source_count[CAVE_COUNT];

#endif